/*
 * Copyright (c) 2008 - 2013  Extensoft, Inc.
 * All Rights Reserved.
 *
 * For redistribution and licensing information please visit: http://www.artisteer.com/?p=code_license_agreement
 * For support and help, please visit our developer's section: http://www.artisteer.com/?p=dev
 *
 */
/*jshint forin:true, noarg:true, noempty:true, eqeqeq:true, bitwise:true, strict:true, undef:true, curly:false, browser:true, jquery:true, devel:true */
/*global content, design, template, result, options*/

function build() {
    'use strict';
    var html, fragments, contentXml, pageContent;
    var htmlContentTemplate = $('.art-post').html();
    var htmlori = $('html').html();

    result.write('output.html', htmlori);
//    $('.art-post').html('<div class="art-postcontent"><!-- include section -->' + htmlContentTemplate + '<!-- end include section --> </div>');
    $('.art-post').html('<!-- include section -->' + htmlContentTemplate + '<!-- end include section -->');
    $('title').html('{site_title}');
    $('.art-headline a').html('{site_title}');
    $('.art-slogan').html('{site_subtitle}');
    $('a').attr("href", "{siteurl}");


    $("form.art-search").attr("action","{siteurl}?mod=search");
    $("form.art-search").attr("method","post");
    $('form.art-search input[type="text"]').attr("name","q");

    //----------------------menu orizzontale----------------------------------->
    $('ul.art-hmenu>li:first').before('\n<!-- include topmenu -->\n');
    $('ul.art-hmenu>li:last').after('\n<!-- end include topmenu -->\n');

    $('ul.art-hmenu>li:first').before('<!-- menuitems -->\n');
    $('ul.art-hmenu>li:last').after('<!-- endmenuitems -->\n');

    $('ul.art-hmenu>li>ul:first').before('<!-- submenu -->\n');
    $('ul.art-hmenu>li>ul:first').after('<!-- endsubmenu -->\n');

    $('ul.art-hmenu>li>ul:first>li:first').before('\n<!-- submenuitems -->\n');
    $('ul.art-hmenu>li>ul:first>li:last').after('\n<!-- endsubmenuitems -->\n');

    $('ul.art-hmenu>li>ul>li:first').before('\n<!-- submenuitem -->\n');
    $('ul.art-hmenu>li>ul>li:first').after('\n<!-- endsubmenuitem -->\n');

    $('ul.art-hmenu>li>ul>li ul').replaceWith("{submenu}");

    $('ul.art-hmenu li:has(a.active):first').before('\n<!-- menuitemactive -->\n');
    $('ul.art-hmenu li:has(a.active):first').after('\n<!-- endmenuitemactive -->\n');

    $('ul.art-hmenu li:not(:has(.active)):first').before('\n<!-- menuitem -->\n');
    $('ul.art-hmenu li:not(:has(.active)):first').after('\n<!-- endmenuitem -->\n');
    
    $('ul.art-hmenu>li:last').remove();
    
    //----------------------menu orizzontale-----------------------------------<
    //------------------------menu verticale----------------------------------->
    $('ul.art-vmenu>li:first').before('\n<!-- include menu -->\n');
    $('ul.art-vmenu>li:last').after('\n<!-- end include menu -->\n');

    $('ul.art-vmenu>li:first').before('<!-- menuitems -->\n');
    $('ul.art-vmenu>li:last').after('<!-- endmenuitems -->\n');

    $('ul.art-vmenu>li>ul:first').before('<!-- submenu -->\n');
    $('ul.art-vmenu>li>ul:first').after('<!-- endsubmenu -->\n');

    $('ul.art-vmenu>li>ul:first>li:first').before('\n<!-- submenuitems -->\n');
    $('ul.art-vmenu>li>ul:first>li:last').after('\n<!-- endsubmenuitems -->\n');

    $('ul.art-vmenu>li>ul>li:first').before('\n<!-- submenuitem -->\n');
    $('ul.art-vmenu>li>ul>li:first').after('\n<!-- endsubmenuitem -->\n');

    $('ul.art-vmenu>li>ul>li ul').replaceWith("{submenu}");

    $('ul.art-vmenu li:has(a.active):first').before('\n<!-- menuitemactive -->\n');
    $('ul.art-vmenu li:has(a.active):first').after('\n<!-- endmenuitemactive -->\n');

    $('ul.art-vmenu li:not(:has(.active)):first').before('\n<!-- menuitem -->\n');
    $('ul.art-vmenu li:not(:has(.active)):first').after('\n<!-- endmenuitem -->\n');
   
    $('ul.art-vmenu>li:last').remove();
    
    
    
    $('.art-vmenublockheader h3').html("Menu");
    //------------------------menu verticale-----------------------------------<

    //-----------------fix submenu sul menu attivo-------------->
    //h
    var hsubmenu = "<!-- submenu --><ul>" + $('ul.art-hmenu li:not(:has(.active)):first ul:first').html() + "</ul><!-- endsubmenu -->";
    $('ul.art-hmenu a.active:first').after(hsubmenu);
    //v
    var vsubmenu = "<!-- submenu --><ul>" + $('ul.art-vmenu li:not(:has(.active)):first ul:first').html() + "</ul><!-- endsubmenu -->";
    $('ul.art-vmenu a.active:first').after(vsubmenu);
    $('ul.art-vmenu li:has(a.active) ul').attr("class","active");
    //-----------------fix submenu sul menu attivo--------------<



    //----------------------------BLOCKS--------------------------------------->
    //---left----->
    $('.art-sidebar1 .art-block:first').before('\n<!-- include blocks_left -->\n');
    $('.art-sidebar1 .art-block:last').after('\n<!-- end include blocks_left -->\n');
    var htmlsidebar = $('.art-sidebar1').html();	
    try {
        htmlsidebar = htmlsidebar.replace("<!-- end include blocks_left -->", "");
    } catch (e) {
        htmlsidebar = "";
                $('.art-block').before("<!-- include blocks_top -->");
        $('.art-block').after("<!-- end include blocks_top -->");

    }
    //---left-----<
    //---right---->
//	$(htmlsidebar).find('.vmenublock').replaceWith("<!-- .. art-vmenublock .. --!>");
//	alert(htmlsidebar);
    $('.art-sidebar2').html(htmlsidebar);
    $('.art-sidebar2 .art-vmenublock').replaceWith("<!-- .. art-vmenublock .. --!>");
    $('.art-sidebar2 .art-vmenublock .art_clearfix').replaceWith("<!-- .. art-vmenublock .. --!>");

    $('.art-sidebar2 .art-block:first').before('\n<!-- include blocks_right -->\n');
    $('.art-sidebar2 .art-block:last').after('\n<!-- end include blocks_right -->\n');
    //---right----<

    //----block item -------->
    $('.art-block').before('<!-- blockitem -->');
    $('.art-block').after('<!-- endblockitem -->');
    $('.art-block .t').html('<!-- blocktitle -->title<!-- endblocktitle -->');
    $('.art-blockcontent').html('<!-- blockcontents -->' + $('.art-blockcontent').html() + '<!-- endblockcontents -->');
    $('.art-blockheader').before('<!-- blockheader -->');
    $('.art-blockheader').after('<!-- endblockheader -->');

    //----block item --------<

    //top e bottom  -------------->
    var htmlblocks = $('.art-sidebar2').html();
    try {
        htmlblocks = htmlblocks.replace("<!-- end include blocks_left -->", "");
        htmlblocks = htmlblocks.replace("<!-- include blocks_left -->", "");
        htmlblocks = htmlblocks.replace("<!-- end include blocks_right -->", "");
        htmlblocks = htmlblocks.replace("<!-- include blocks_right -->", "");
    } catch (e) {
        htmlblocks = "";
    }
    if (htmlblocks != "")
    {
        $('.art-post').before("<!-- include blocks_top -->" + htmlblocks + "<!-- end include blocks_top -->");
        $('.art-post').after("<!-- include blocks_bottom -->" + htmlblocks + "<!-- end include blocks_bottom -->");
    }
    //top e bottom  --------------<
    //----------------------------BLOCKS---------------------------------------<
    //----------------------------FOOTER--------------------------------------->
    $('.art-footer').html("{hmenu}");
    $('.art-page-footer').html("{credits}");
    //----------------------------FOOTER---------------------------------------<


    

    // get fragments from Artisteer design      
    fragments = {
        page_head: $('head').html(),
        page_body: $('body').html()
    };
    // get the styles and content of the first page from the content.xml file      
    contentXml = $.parseXML(content.read('content.xml'));
    pageContent = $('page:eq(0)', contentXml);
    fragments.content = pageContent.children('content').text();
    fragments.content_styles = pageContent.children('pageHead').text();

    // get index.html and replace the placeholders      
    html = template.read('art-template.tp.html');
    var searchPattern = /\{\{([\w_]+)\}\}/g;
    var placeholderReplacer = function(str, ph) {
        return fragments[ph];
    };
    while (html.search(searchPattern) !== -1) {

        html = html.replace(searchPattern, placeholderReplacer);

    }
    //html = str_replace ("art-search", "searchform", html);

    
    var css_str="" ;
    
    //news ----->
    var htmlnews;
	$(".art-postcontent-0").html(" {$_IMAGENEWS}{$_IMAGEARGUMENT}{$item['news_SUMMARY']}{$_READBUTTON}{$item['facebook_button_i_like']} ");
	$(".art-postcommentsicon").html(" ");
	$(".art-comment").html(" ");
	$(".art-commentsform").remove();
	$(".art-pager").remove();
	$("#comments").remove();
	
	$(".art-postauthoricon").html("$_NEWS_USER");
	$(".art-postheadericons.art-metadata-icons").html("<span class=\"art-postdateicon\">{$item['txt_DATE']}</span>"
                        +" | <span class=\"art-postauthoricon\"> $_NEWS_USER</span> "
                        +" | <span class=\"art-postpdficon\" onclick=\"window.open('{$item['link_PDF']}');\"></span>"
                        +" | <span class=\"art-postprinticon\" onclick=\"window.open('{$item['link_PRINT']}');\"></span>"
                        +" | <span class=\"art-postemailicon\" onclick=\"window.open('$_MAILTO');\"></span>"
                        +" $_MODIFY</span>"
						);
	$(".art-postfootericons.art-metadata-icons").html(" <span class=\"art-postcategoryicon\">{$item['news_CATEGORY']}</span> $_TAGS $_COMMENTS ");
	var tit = $("h2.art-postheader").html();
	tit = str_replace("Post","<a accesskey=\"{$item['accesskey_READ']}\" href=\"{$item['link_READ']}\">{$item['title']}</a>",tit);
	$("h2.art-postheader").html(tit);
    htmlnews = "<article class=\"art-post art-article\">"+$("article").html()+"</article>";
	htmlnews = str_replace("<!-- include section -->","",htmlnews);
	htmlnews = str_replace("<!-- end include section -->","",htmlnews);
    var htmltplnews;
    htmltplnews = template.read('templatenews.php');
    htmltplnews = htmltplnews.replace("___STRNEWS___",str_replace('"','\\"',htmlnews));
    htmltplnews = str_replace ("art-search", "searchform", htmltplnews);
    result.write('theme.php', htmltplnews);
    //news -----<
    
	
    // write the resulting html code to the export files      
    result.write('template.tp.html', html);
	//
	var html_news = html.split("<article")[0]+'<!-- include section --> news <!-- end include section -->';
	var tmp = html.split("</article>").pop();
	html_news = html_news+tmp;
    result.write('template.type.news.tp.html', html_news);
    // copy Artisteer-generated styles and images      
    design.copyTo('/', result, '/');
    // copy content images  
    if (content.exists('images')) {
        content.copyTo('images', result, '');
    }
	
	
    css_str = result.read('style.css');
    //css_str = str_replace ("form.art-search", "form.searchform", css_str);
    css_str = css_str.replace (".art-button", ".art-button,button", css_str);
    result.write('style.css', css_str+"\n.readallbutton{clear:both}\n");
    
    var str_fck =  str_replace("url('","url('../",css_str);
    str_fck =  str_replace(".art-postcontent","body",str_fck);
    
    result.write('ckeditor/style.css',str_fck);
    
    
    
    
    //config ----->
    var htmltplconfig;
    htmltplconfig = template.read('templateconfig.php');
    result.write('config.php', htmltplconfig);
    //config -----<
}


function str_replace (search, replace, subject, count) {
  
  var i = 0,
    j = 0,
    temp = '',
    repl = '',
    sl = 0,
    fl = 0,
    f = [].concat(search),
    r = [].concat(replace),
    s = subject,
    ra = Object.prototype.toString.call(r) === '[object Array]',
    sa = Object.prototype.toString.call(s) === '[object Array]';
  s = [].concat(s);
  if (count) {
    this.window[count] = 0;
  }

  for (i = 0, sl = s.length; i < sl; i++) {
    if (s[i] === '') {
      continue;
    }
    for (j = 0, fl = f.length; j < fl; j++) {
      temp = s[i] + '';
      repl = ra ? (r[j] !== undefined ? r[j] : '') : r[0];
      s[i] = (temp).split(f[j]).join(repl);
      if (count && s[i] !== temp) {
        this.window[count] += (temp.length - s[i].length) / f[j].length;
      }
    }
  }
  return sa ? s : s[0];
}
